require 'hubspot'

module Hubspot
  module Api
    module TransactionEmail
      class SingleSend
        class KeyError < StandardError; end

        attr_accessor :hapikey

        def initialize(hapikey)
          @hapikey = hapikey
        end

        class << self
          def post(options)
            config = Hubspot.configuration
            SingleSend.new(config.hapikey).post(options)
          end
        end

        def post(options = {})
          raise ArgumentError, "EmailId: Required Error" if options.dig(:emailId).blank? 
          raise ArgumentError, "To: Required Error" if options.dig(:message, :to).blank?
          raise KeyError, "Hubspot Api Key Error" if hapikey.blank?

          response = Hubspot.post("/email/public/v1/singleEmail/send?hapikey=#{hapikey}", options)
          if response[:status] == "200"
            response
          else
            raise StandardError, "Something went wrong!"
          end
        end
      end
    end
  end
end